diff --git a/sys/dev/drm/nouveau/core/engine/disp/nouveau_engine_disp_nv50.c b/sys/dev/drm/nouveau/core/engine/disp/nouveau_engine_disp_nv50.c
index f8cbb51213..0deeaea5af 100644
--- a/sys/dev/drm/nouveau/core/engine/disp/nouveau_engine_disp_nv50.c
+++ b/sys/dev/drm/nouveau/core/engine/disp/nouveau_engine_disp_nv50.c
@@ -258,9 +258,9 @@ nv50_disp_mthd_list(struct nv50_disp_priv *priv, int debug, u32 base, int c,
 			char mods[16];
 
 			if (prev != next)
-				snprintf(mods, sizeof(mods), "-> 0x%08x", next);
+				ksnprintf(mods, sizeof(mods), "-> 0x%08x", next);
 			else
-				snprintf(mods, sizeof(mods), "%13c", ' ');
+				ksnprintf(mods, sizeof(mods), "%13c", ' ');
 
 			nv_printk_(disp, debug, "\t0x%04x: 0x%08x %s%s%s\n",
 				   mthd, prev, mods, name ? " // " : "",
@@ -289,13 +289,13 @@ nv50_disp_mthd_chan(struct nv50_disp_priv *priv, int debug, int head,
 			char cname_[16], sname_[16];
 
 			if (chan->addr) {
-				snprintf(cname_, sizeof(cname_), "%s %d",
+				ksnprintf(cname_, sizeof(cname_), "%s %d",
 					 chan->name, head);
 				cname = cname_;
 			}
 
 			if (chan->data[i].nr > 1) {
-				snprintf(sname_, sizeof(sname_), " - %s %d",
+				ksnprintf(sname_, sizeof(sname_), " - %s %d",
 					 chan->data[i].name, j);
 				sname = sname_;
 			}
@@ -914,7 +914,7 @@ nv50_disp_base_mthd(struct nouveau_object *object, u32 mthd,
 	struct nv50_disp_priv *priv = (void *)object->engine;
 	struct nvkm_output *outp = NULL;
 	struct nvkm_output *temp;
-	u16 type, mask = 0;
+	u16 type = 0, mask = 0;
 	int head, ret;
 
 	if (mthd != NV50_DISP_MTHD)
@@ -1262,11 +1262,11 @@ nv50_disp_intr_error(struct nv50_disp_priv *priv, int chid)
 
 	et = nouveau_enum_find(nv50_disp_intr_error_type, type);
 	if (!et)
-		snprintf(etunk, sizeof(etunk), "UNK%02X", type);
+		ksnprintf(etunk, sizeof(etunk), "UNK%02X", type);
 
 	ec = nouveau_enum_find(nv50_disp_intr_error_code, code);
 	if (!ec)
-		snprintf(ecunk, sizeof(ecunk), "UNK%02X", code);
+		ksnprintf(ecunk, sizeof(ecunk), "UNK%02X", code);
 
 	nv_error(priv, "%s [%s] chid %d mthd 0x%04x data 0x%08x\n",
 		 et ? et->name : etunk, ec ? ec->name : ecunk,
diff --git a/sys/dev/drm/nouveau/core/engine/dmaobj/nouveau_engine_dmaobj_base.c b/sys/dev/drm/nouveau/core/engine/dmaobj/nouveau_engine_dmaobj_base.c
index e1500f77a5..416773f8d8 100644
--- a/sys/dev/drm/nouveau/core/engine/dmaobj/nouveau_engine_dmaobj_base.c
+++ b/sys/dev/drm/nouveau/core/engine/dmaobj/nouveau_engine_dmaobj_base.c
@@ -80,7 +80,7 @@ nvkm_dmaobj_create_(struct nouveau_object *parent,
 	nv_ioctl(parent, "create dma size %d\n", *psize);
 	if (nvif_unpack(args->v0, 0, 0, true)) {
 		nv_ioctl(parent, "create dma vers %d target %d access %d "
-				 "start %016llx limit %016llx\n",
+				 "start %016lx limit %016lx\n",
 			 args->v0.version, args->v0.target, args->v0.access,
 			 args->v0.start, args->v0.limit);
 		dmaobj->target = args->v0.target;
diff --git a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_base.c b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_base.c
index 0f999fc45a..ff4f74ace2 100644
--- a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_base.c
+++ b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_base.c
@@ -118,7 +118,7 @@ nouveau_fifo_channel_destroy(struct nouveau_fifo_chan *chan)
 	unsigned long flags;
 
 	if (chan->user)
-		iounmap(chan->user);
+		iounmap(chan->user, chan->size);
 
 	spin_lock_irqsave(&priv->lock, flags);
 	priv->channel[chan->chid] = NULL;
diff --git a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv04.c b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv04.c
index 5ae6a43893..a842b2a0d5 100644
--- a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv04.c
+++ b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv04.c
@@ -128,7 +128,7 @@ nv04_fifo_chan_ctor(struct nouveau_object *parent,
 	nv_ioctl(parent, "create channel dma size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
 		nv_ioctl(parent, "create channel dma vers %d pushbuf %08x "
-				 "offset %016llx\n", args->v0.version,
+				 "offset %016lx\n", args->v0.version,
 			 args->v0.pushbuf, args->v0.offset);
 	} else
 		return ret;
@@ -308,7 +308,7 @@ nv04_fifo_pause(struct nouveau_fifo *pfifo, unsigned long *pflags)
 __acquires(priv->base.lock)
 {
 	struct nv04_fifo_priv *priv = (void *)pfifo;
-	unsigned long flags;
+	unsigned long flags = 0;
 
 	spin_lock_irqsave(&priv->base.lock, flags);
 	*pflags = flags;
diff --git a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv10.c b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv10.c
index 2a32add51c..f9e1ce7f76 100644
--- a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv10.c
+++ b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv10.c
@@ -70,7 +70,7 @@ nv10_fifo_chan_ctor(struct nouveau_object *parent,
 	nv_ioctl(parent, "create channel dma size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
 		nv_ioctl(parent, "create channel dma vers %d pushbuf %08x "
-				 "offset %016llx\n", args->v0.version,
+				 "offset %016lx\n", args->v0.version,
 			 args->v0.pushbuf, args->v0.offset);
 	} else
 		return ret;
diff --git a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv17.c b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv17.c
index 12d76c8adb..340cd2c521 100644
--- a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv17.c
+++ b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv17.c
@@ -75,7 +75,7 @@ nv17_fifo_chan_ctor(struct nouveau_object *parent,
 	nv_ioctl(parent, "create channel dma size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
 		nv_ioctl(parent, "create channel dma vers %d pushbuf %08x "
-				 "offset %016llx\n", args->v0.version,
+				 "offset %016lx\n", args->v0.version,
 			 args->v0.pushbuf, args->v0.offset);
 	} else
 		return ret;
diff --git a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv40.c b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv40.c
index 9f49c3a24d..4ab691a6a3 100644
--- a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv40.c
+++ b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv40.c
@@ -193,7 +193,7 @@ nv40_fifo_chan_ctor(struct nouveau_object *parent,
 	nv_ioctl(parent, "create channel dma size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
 		nv_ioctl(parent, "create channel dma vers %d pushbuf %08x "
-				 "offset %016llx\n", args->v0.version,
+				 "offset %016lx\n", args->v0.version,
 			 args->v0.pushbuf, args->v0.offset);
 	} else
 		return ret;
diff --git a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv50.c b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv50.c
index 5d1e86bc24..359323f515 100644
--- a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv50.c
+++ b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv50.c
@@ -206,7 +206,7 @@ nv50_fifo_chan_ctor_dma(struct nouveau_object *parent,
 	nv_ioctl(parent, "create channel dma size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
 		nv_ioctl(parent, "create channel dma vers %d pushbuf %08x "
-				 "offset %016llx\n", args->v0.version,
+				 "offset %016lx\n", args->v0.version,
 			 args->v0.pushbuf, args->v0.offset);
 	} else
 		return ret;
@@ -269,7 +269,7 @@ nv50_fifo_chan_ctor_ind(struct nouveau_object *parent,
 	nv_ioctl(parent, "create channel gpfifo size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
 		nv_ioctl(parent, "create channel gpfifo vers %d pushbuf %08x "
-				 "ioffset %016llx ilength %08x\n",
+				 "ioffset %016lx ilength %08x\n",
 			 args->v0.version, args->v0.pushbuf, args->v0.ioffset,
 			 args->v0.ilength);
 	} else
diff --git a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv84.c b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv84.c
index 1f42996b35..061aa5f533 100644
--- a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv84.c
+++ b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nv84.c
@@ -172,7 +172,7 @@ nv84_fifo_chan_ctor_dma(struct nouveau_object *parent,
 	nv_ioctl(parent, "create channel dma size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
 		nv_ioctl(parent, "create channel dma vers %d pushbuf %08x "
-				 "offset %016llx\n", args->v0.version,
+				 "offset %016lx\n", args->v0.version,
 			 args->v0.pushbuf, args->v0.offset);
 	} else
 		return ret;
@@ -244,7 +244,7 @@ nv84_fifo_chan_ctor_ind(struct nouveau_object *parent,
 	nv_ioctl(parent, "create channel gpfifo size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
 		nv_ioctl(parent, "create channel gpfifo vers %d pushbuf %08x "
-				 "ioffset %016llx ilength %08x\n",
+				 "ioffset %016lx ilength %08x\n",
 			 args->v0.version, args->v0.pushbuf, args->v0.ioffset,
 			 args->v0.ilength);
 	} else
diff --git a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nvc0.c b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nvc0.c
index 1fe1f8fbda..8e1f73e971 100644
--- a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nvc0.c
+++ b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nvc0.c
@@ -201,7 +201,7 @@ nvc0_fifo_chan_ctor(struct nouveau_object *parent,
 	nv_ioctl(parent, "create channel gpfifo size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
 		nv_ioctl(parent, "create channel gpfifo vers %d pushbuf %08x "
-				 "ioffset %016llx ilength %08x\n",
+				 "ioffset %016lx ilength %08x\n",
 			 args->v0.version, args->v0.pushbuf, args->v0.ioffset,
 			 args->v0.ilength);
 	} else
@@ -529,7 +529,7 @@ nvc0_fifo_intr_sched(struct nvc0_fifo_priv *priv)
 
 	en = nouveau_enum_find(nvc0_fifo_sched_reason, code);
 	if (!en)
-		snprintf(enunk, sizeof(enunk), "UNK%02x", code);
+		ksnprintf(enunk, sizeof(enunk), "UNK%02x", code);
 
 	nv_error(priv, "SCHED_ERROR [ %s ]\n", en ? en->name : enunk);
 
@@ -623,7 +623,7 @@ nvc0_fifo_intr_fault(struct nvc0_fifo_priv *priv, int unit)
 
 	er = nouveau_enum_find(nvc0_fifo_fault_reason, reason);
 	if (!er)
-		snprintf(erunk, sizeof(erunk), "UNK%02X", reason);
+		ksnprintf(erunk, sizeof(erunk), "UNK%02X", reason);
 
 	eu = nouveau_enum_find(nvc0_fifo_fault_engine, unit);
 	if (eu) {
@@ -644,21 +644,21 @@ nvc0_fifo_intr_fault(struct nvc0_fifo_priv *priv, int unit)
 			break;
 		}
 	} else {
-		snprintf(euunk, sizeof(euunk), "UNK%02x", unit);
+		ksnprintf(euunk, sizeof(euunk), "UNK%02x", unit);
 	}
 
 	if (hub) {
 		ec = nouveau_enum_find(nvc0_fifo_fault_hubclient, client);
 	} else {
 		ec = nouveau_enum_find(nvc0_fifo_fault_gpcclient, client);
-		snprintf(gpcid, sizeof(gpcid), "%d", gpc);
+		ksnprintf(gpcid, sizeof(gpcid), "%d", gpc);
 	}
 
 	if (!ec)
-		snprintf(ecunk, sizeof(ecunk), "UNK%02x", client);
+		ksnprintf(ecunk, sizeof(ecunk), "UNK%02x", client);
 
-	nv_error(priv, "%s fault at 0x%010llx [%s] from %s/%s%s%s%s on "
-		       "channel 0x%010llx [%s]\n", write ? "write" : "read",
+	nv_error(priv, "%s fault at 0x%010lx [%s] from %s/%s%s%s%s on "
+		       "channel 0x%010lx [%s]\n", write ? "write" : "read",
 		 (u64)vahi << 32 | valo, er ? er->name : erunk,
 		 eu ? eu->name : euunk, hub ? "" : "GPC", gpcid, hub ? "" : "/",
 		 ec ? ec->name : ecunk, (u64)inst << 12,
diff --git a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nve0.c b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nve0.c
index d2f0fd39c1..076719264b 100644
--- a/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nve0.c
+++ b/sys/dev/drm/nouveau/core/engine/fifo/nouveau_engine_fifo_nve0.c
@@ -230,7 +230,7 @@ nve0_fifo_chan_ctor(struct nouveau_object *parent,
 	nv_ioctl(parent, "create channel gpfifo size %d\n", size);
 	if (nvif_unpack(args->v0, 0, 0, false)) {
 		nv_ioctl(parent, "create channel gpfifo vers %d pushbuf %08x "
-				 "ioffset %016llx ilength %08x engine %08x\n",
+				 "ioffset %016lx ilength %08x engine %08x\n",
 			 args->v0.version, args->v0.pushbuf, args->v0.ioffset,
 			 args->v0.ilength, args->v0.engine);
 	} else
@@ -534,7 +534,7 @@ nve0_fifo_intr_bind(struct nve0_fifo_priv *priv)
 
 	en = nouveau_enum_find(nve0_fifo_bind_reason, code);
 	if (!en)
-		snprintf(enunk, sizeof(enunk), "UNK%02x", code);
+		ksnprintf(enunk, sizeof(enunk), "UNK%02x", code);
 
 	nv_error(priv, "BIND_ERROR [ %s ]\n", en ? en->name : enunk);
 }
@@ -583,7 +583,7 @@ nve0_fifo_intr_sched(struct nve0_fifo_priv *priv)
 
 	en = nouveau_enum_find(nve0_fifo_sched_reason, code);
 	if (!en)
-		snprintf(enunk, sizeof(enunk), "UNK%02x", code);
+		ksnprintf(enunk, sizeof(enunk), "UNK%02x", code);
 
 	nv_error(priv, "SCHED_ERROR [ %s ]\n", en ? en->name : enunk);
 
@@ -738,7 +738,7 @@ nve0_fifo_intr_fault(struct nve0_fifo_priv *priv, int unit)
 
 	er = nouveau_enum_find(nve0_fifo_fault_reason, reason);
 	if (!er)
-		snprintf(erunk, sizeof(erunk), "UNK%02X", reason);
+		ksnprintf(erunk, sizeof(erunk), "UNK%02X", reason);
 
 	eu = nouveau_enum_find(nve0_fifo_fault_engine, unit);
 	if (eu) {
@@ -759,21 +759,21 @@ nve0_fifo_intr_fault(struct nve0_fifo_priv *priv, int unit)
 			break;
 		}
 	} else {
-		snprintf(euunk, sizeof(euunk), "UNK%02x", unit);
+		ksnprintf(euunk, sizeof(euunk), "UNK%02x", unit);
 	}
 
 	if (hub) {
 		ec = nouveau_enum_find(nve0_fifo_fault_hubclient, client);
 	} else {
 		ec = nouveau_enum_find(nve0_fifo_fault_gpcclient, client);
-		snprintf(gpcid, sizeof(gpcid), "%d", gpc);
+		ksnprintf(gpcid, sizeof(gpcid), "%d", gpc);
 	}
 
 	if (!ec)
-		snprintf(ecunk, sizeof(ecunk), "UNK%02x", client);
+		ksnprintf(ecunk, sizeof(ecunk), "UNK%02x", client);
 
-	nv_error(priv, "%s fault at 0x%010llx [%s] from %s/%s%s%s%s on "
-		       "channel 0x%010llx [%s]\n", write ? "write" : "read",
+	nv_error(priv, "%s fault at 0x%010lx [%s] from %s/%s%s%s%s on "
+		       "channel 0x%010lx [%s]\n", write ? "write" : "read",
 		 (u64)vahi << 32 | valo, er ? er->name : erunk,
 		 eu ? eu->name : euunk, hub ? "" : "GPC", gpcid, hub ? "" : "/",
 		 ec ? ec->name : ecunk, (u64)inst << 12,
diff --git a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxgm107.c b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxgm107.c
index 62e918b9fa..179c7429cd 100644
--- a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxgm107.c
+++ b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxgm107.c
@@ -894,7 +894,7 @@ static void
 gm107_grctx_generate_attrib(struct nvc0_grctx *info)
 {
 	struct nvc0_graph_priv *priv = info->priv;
-	const struct nvc0_grctx_oclass *impl = (void *)nvc0_grctx_impl(priv);
+	const struct nvc0_grctx_oclass *impl = nvc0_grctx_impl(priv);
 	const u32  alpha = impl->alpha_nr;
 	const u32 attrib = impl->attrib_nr;
 	const u32   size = 0x20 * (impl->attrib_nr_max + impl->alpha_nr_max);
diff --git a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnv40.c b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnv40.c
index 7bbb1e1b7a..c32d79165b 100644
--- a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnv40.c
+++ b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnv40.c
@@ -672,7 +672,7 @@ nv40_grctx_fill(struct nouveau_device *device, struct nouveau_gpuobj *mem)
 int
 nv40_grctx_init(struct nouveau_device *device, u32 *size)
 {
-	u32 *ctxprog = kmalloc(256 * 4, GFP_KERNEL), i;
+	u32 *ctxprog = kmalloc(256 * 4, M_DRM, GFP_KERNEL), i;
 	struct nouveau_grctx ctx = {
 		.device = device,
 		.mode = NOUVEAU_GRCTX_PROG,
diff --git a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnv50.c b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnv50.c
index 552fdbd45e..592bc7a723 100644
--- a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnv50.c
+++ b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnv50.c
@@ -265,7 +265,7 @@ nv50_grctx_fill(struct nouveau_device *device, struct nouveau_gpuobj *mem)
 int
 nv50_grctx_init(struct nouveau_device *device, u32 *size)
 {
-	u32 *ctxprog = kmalloc(512 * 4, GFP_KERNEL), i;
+	u32 *ctxprog = kmalloc(512 * 4, M_DRM, GFP_KERNEL), i;
 	struct nouveau_grctx ctx = {
 		.device = device,
 		.mode = NOUVEAU_GRCTX_PROG,
diff --git a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnvc0.c b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnvc0.c
index b8e5fe60a1..d84e48ac3c 100644
--- a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnvc0.c
+++ b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnvc0.c
@@ -1343,7 +1343,7 @@ nvc0_grctx_generate(struct nvc0_graph_priv *priv)
 		goto done;
 	}
 
-	priv->data = kmalloc(priv->size, GFP_KERNEL);
+	priv->data = kmalloc(priv->size, M_DRM, GFP_KERNEL);
 	if (priv->data) {
 		for (i = 0; i < priv->size; i += 4)
 			priv->data[i / 4] = nv_ro32(chan, 0x80000 + i);
diff --git a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnvd7.c b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnvd7.c
index fcf534fd9e..0f8c0b8d1b 100644
--- a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnvd7.c
+++ b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_ctxnvd7.c
@@ -214,7 +214,7 @@ nvd7_grctx_generate_attrib(struct nvc0_grctx *info)
 	}
 }
 
-void
+static void
 nvd7_grctx_generate_main(struct nvc0_graph_priv *priv, struct nvc0_grctx *info)
 {
 	struct nvc0_grctx_oclass *oclass = (void *)nv_engine(priv)->cclass;
diff --git a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_gm107.c b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_gm107.c
index 4bdbdab2fd..8b266c4635 100644
--- a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_gm107.c
+++ b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_gm107.c
@@ -318,7 +318,7 @@ gm107_graph_init_bios(struct nvc0_graph_priv *priv)
 	}
 }
 
-int
+static int
 gm107_graph_init(struct nouveau_object *object)
 {
 	struct nvc0_graph_oclass *oclass = (void *)object->oclass;
diff --git a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv04.c b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv04.c
index f70e2f67a4..cb5e7c3f5e 100644
--- a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv04.c
+++ b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv04.c
@@ -354,7 +354,7 @@ nv04_graph_ctx_regs[] = {
 struct nv04_graph_priv {
 	struct nouveau_graph base;
 	struct nv04_graph_chan *chan[16];
-	spinlock_t lock;
+	struct spinlock lock;
 };
 
 struct nv04_graph_chan {
diff --git a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv10.c b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv10.c
index 2b12b09683..730d3088ff 100644
--- a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv10.c
+++ b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv10.c
@@ -392,7 +392,7 @@ static int nv17_graph_ctx_regs[] = {
 struct nv10_graph_priv {
 	struct nouveau_graph base;
 	struct nv10_graph_chan *chan[32];
-	spinlock_t lock;
+	struct spinlock lock;
 };
 
 struct nv10_graph_chan {
diff --git a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv50.c b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv50.c
index 38e0aa26f1..e976b6d90b 100644
--- a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv50.c
+++ b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nv50.c
@@ -39,7 +39,7 @@
 
 struct nv50_graph_priv {
 	struct nouveau_graph base;
-	spinlock_t lock;
+	struct spinlock lock;
 	u32 size;
 };
 
@@ -615,7 +615,7 @@ nv50_graph_trap_handler(struct nv50_graph_priv *priv, u32 display,
 			nv_error(priv, "TRAP DISPATCH_FAULT\n");
 			if (display && (addr & 0x80000000)) {
 				nv_error(priv,
-					 "ch %d [0x%010llx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x%08x 400808 0x%08x 400848 0x%08x\n",
+					 "ch %d [0x%010lx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x%08x 400808 0x%08x 400848 0x%08x\n",
 					 chid, inst,
 					 nouveau_client_name(engctx), subc,
 					 class, mthd, datah, datal, addr, r848);
@@ -640,7 +640,7 @@ nv50_graph_trap_handler(struct nv50_graph_priv *priv, u32 display,
 			nv_error(priv, "TRAP DISPATCH_QUERY\n");
 			if (display && (addr & 0x80000000)) {
 				nv_error(priv,
-					 "ch %d [0x%010llx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x 40084c 0x%08x\n",
+					 "ch %d [0x%010lx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x 40084c 0x%08x\n",
 					 chid, inst,
 					 nouveau_client_name(engctx), subc,
 					 class, mthd, data, addr);
@@ -844,7 +844,7 @@ nv50_graph_intr(struct nouveau_subdev *subdev)
 			pr_cont("\n");
 		}
 		nv_error(priv,
-			 "ch %d [0x%010llx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x\n",
+			 "ch %d [0x%010lx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x\n",
 			 chid, (u64)inst << 12, nouveau_client_name(engctx),
 			 subc, class, mthd, data);
 	}
diff --git a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nvc0.c b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nvc0.c
index 30fd1dc64f..95726443db 100644
--- a/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nvc0.c
+++ b/sys/dev/drm/nouveau/core/engine/graph/nouveau_engine_graph_nvc0.c
@@ -1096,7 +1096,7 @@ nvc0_graph_intr(struct nouveau_subdev *subdev)
 		handle = nouveau_handle_get_class(engctx, class);
 		if (!handle || nv_call(handle->object, mthd, data)) {
 			nv_error(priv,
-				 "ILLEGAL_MTHD ch %d [0x%010llx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x\n",
+				 "ILLEGAL_MTHD ch %d [0x%010lx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x\n",
 				 chid, inst << 12, nouveau_client_name(engctx),
 				 subc, class, mthd, data);
 		}
@@ -1107,7 +1107,7 @@ nvc0_graph_intr(struct nouveau_subdev *subdev)
 
 	if (stat & 0x00000020) {
 		nv_error(priv,
-			 "ILLEGAL_CLASS ch %d [0x%010llx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x\n",
+			 "ILLEGAL_CLASS ch %d [0x%010lx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x\n",
 			 chid, inst << 12, nouveau_client_name(engctx), subc,
 			 class, mthd, data);
 		nv_wr32(priv, 0x400100, 0x00000020);
@@ -1117,7 +1117,7 @@ nvc0_graph_intr(struct nouveau_subdev *subdev)
 	if (stat & 0x00100000) {
 		nv_error(priv, "DATA_ERROR [");
 		nouveau_enum_print(nv50_data_error_names, code);
-		pr_cont("] ch %d [0x%010llx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x\n",
+		pr_cont("] ch %d [0x%010lx %s] subc %d class 0x%04x mthd 0x%04x data 0x%08x\n",
 			chid, inst << 12, nouveau_client_name(engctx), subc,
 			class, mthd, data);
 		nv_wr32(priv, 0x400100, 0x00100000);
@@ -1125,7 +1125,7 @@ nvc0_graph_intr(struct nouveau_subdev *subdev)
 	}
 
 	if (stat & 0x00200000) {
-		nv_error(priv, "TRAP ch %d [0x%010llx %s]\n", chid, inst << 12,
+		nv_error(priv, "TRAP ch %d [0x%010lx %s]\n", chid, inst << 12,
 			 nouveau_client_name(engctx));
 		nvc0_graph_trap_intr(priv);
 		nv_wr32(priv, 0x400100, 0x00200000);
@@ -1147,7 +1147,7 @@ nvc0_graph_intr(struct nouveau_subdev *subdev)
 	nouveau_engctx_put(engctx);
 }
 
-void
+static void
 nvc0_graph_init_fw(struct nvc0_graph_priv *priv, u32 fuc_base,
 		   struct nvc0_graph_fuc *code, struct nvc0_graph_fuc *data)
 {
@@ -1482,7 +1482,7 @@ nvc0_graph_dtor_fw(struct nvc0_graph_fuc *fuc)
 	fuc->data = NULL;
 }
 
-int
+static int
 nvc0_graph_ctor_fw(struct nvc0_graph_priv *priv, const char *fwname,
 		   struct nvc0_graph_fuc *fuc)
 {
@@ -1491,10 +1491,10 @@ nvc0_graph_ctor_fw(struct nvc0_graph_priv *priv, const char *fwname,
 	char f[32];
 	int ret;
 
-	snprintf(f, sizeof(f), "nouveau/nv%02x_%s", device->chipset, fwname);
+	ksnprintf(f, sizeof(f), "nouveau/nv%02x_%s", device->chipset, fwname);
 	ret = request_firmware(&fw, f, nv_device_base(device));
 	if (ret) {
-		snprintf(f, sizeof(f), "nouveau/%s", fwname);
+		ksnprintf(f, sizeof(f), "nouveau/%s", fwname);
 		ret = request_firmware(&fw, f, nv_device_base(device));
 		if (ret) {
 			nv_error(priv, "failed to load %s\n", fwname);
@@ -1502,7 +1502,7 @@ nvc0_graph_ctor_fw(struct nvc0_graph_priv *priv, const char *fwname,
 		}
 	}
 
-	fuc->size = fw->size;
+	fuc->size = fw->datasize;
 	fuc->data = kmemdup(fw->data, fuc->size, GFP_KERNEL);
 	release_firmware(fw);
 	return (fuc->data != NULL) ? 0 : -ENOMEM;
diff --git a/sys/dev/drm/nouveau/core/engine/nouveau_engine_falcon.c b/sys/dev/drm/nouveau/core/engine/nouveau_engine_falcon.c
index 2914646c87..48c0a1d581 100644
--- a/sys/dev/drm/nouveau/core/engine/nouveau_engine_falcon.c
+++ b/sys/dev/drm/nouveau/core/engine/nouveau_engine_falcon.c
@@ -116,13 +116,13 @@ _nouveau_falcon_init(struct nouveau_object *object)
 	 * locate a "self-bootstrapping" firmware image for the engine
 	 */
 	if (!falcon->code.data) {
-		snprintf(name, sizeof(name), "nouveau/nv%02x_fuc%03x",
+		ksnprintf(name, sizeof(name), "nouveau/nv%02x_fuc%03x",
 			 device->chipset, falcon->addr >> 12);
 
 		ret = request_firmware(&fw, name, nv_device_base(device));
 		if (ret == 0) {
-			falcon->code.data = vmemdup(fw->data, fw->size);
-			falcon->code.size = fw->size;
+			falcon->code.data = vmemdup(fw->data, fw->datasize);
+			falcon->code.size = fw->datasize;
 			falcon->data.data = NULL;
 			falcon->data.size = 0;
 			release_firmware(fw);
@@ -135,7 +135,7 @@ _nouveau_falcon_init(struct nouveau_object *object)
 	 * images for the engine
 	 */
 	if (!falcon->code.data) {
-		snprintf(name, sizeof(name), "nouveau/nv%02x_fuc%03xd",
+		ksnprintf(name, sizeof(name), "nouveau/nv%02x_fuc%03xd",
 			 device->chipset, falcon->addr >> 12);
 
 		ret = request_firmware(&fw, name, nv_device_base(device));
@@ -144,13 +144,13 @@ _nouveau_falcon_init(struct nouveau_object *object)
 			return ret;
 		}
 
-		falcon->data.data = vmemdup(fw->data, fw->size);
-		falcon->data.size = fw->size;
+		falcon->data.data = vmemdup(fw->data, fw->datasize);
+		falcon->data.size = fw->datasize;
 		release_firmware(fw);
 		if (!falcon->data.data)
 			return -ENOMEM;
 
-		snprintf(name, sizeof(name), "nouveau/nv%02x_fuc%03xc",
+		ksnprintf(name, sizeof(name), "nouveau/nv%02x_fuc%03xc",
 			 device->chipset, falcon->addr >> 12);
 
 		ret = request_firmware(&fw, name, nv_device_base(device));
@@ -159,8 +159,8 @@ _nouveau_falcon_init(struct nouveau_object *object)
 			return ret;
 		}
 
-		falcon->code.data = vmemdup(fw->data, fw->size);
-		falcon->code.size = fw->size;
+		falcon->code.data = vmemdup(fw->data, fw->datasize);
+		falcon->code.size = fw->datasize;
 		release_firmware(fw);
 		if (!falcon->code.data)
 			return -ENOMEM;
diff --git a/sys/dev/drm/nouveau/core/engine/nouveau_engine_xtensa.c b/sys/dev/drm/nouveau/core/engine/nouveau_engine_xtensa.c
index 92384759d2..da746210f7 100644
--- a/sys/dev/drm/nouveau/core/engine/nouveau_engine_xtensa.c
+++ b/sys/dev/drm/nouveau/core/engine/nouveau_engine_xtensa.c
@@ -109,7 +109,7 @@ _nouveau_xtensa_init(struct nouveau_object *object)
 		return ret;
 
 	if (!xtensa->gpu_fw) {
-		snprintf(name, sizeof(name), "nouveau/nv84_xuc%03x",
+		ksnprintf(name, sizeof(name), "nouveau/nv84_xuc%03x",
 			 xtensa->addr >> 12);
 
 		ret = request_firmware(&fw, name, nv_device_base(device));
@@ -118,7 +118,7 @@ _nouveau_xtensa_init(struct nouveau_object *object)
 			return ret;
 		}
 
-		if (fw->size > 0x40000) {
+		if (fw->datasize > 0x40000) {
 			nv_warn(xtensa, "firmware %s too large\n", name);
 			release_firmware(fw);
 			return -EINVAL;
@@ -131,11 +131,11 @@ _nouveau_xtensa_init(struct nouveau_object *object)
 			return ret;
 		}
 
-		nv_debug(xtensa, "Loading firmware to address: 0x%llx\n",
+		nv_debug(xtensa, "Loading firmware to address: 0x%lx\n",
 			 xtensa->gpu_fw->addr);
 
-		for (i = 0; i < fw->size / 4; i++)
-			nv_wo32(xtensa->gpu_fw, i * 4, *((u32 *)fw->data + i));
+		for (i = 0; i < fw->datasize / 4; i++)
+			nv_wo32(xtensa->gpu_fw, i * 4, *((const u32 *)fw->data + i));
 		release_firmware(fw);
 	}
 
diff --git a/sys/dev/drm/nouveau/core/engine/perfmon/nouveau_engine_perfmon_base.c b/sys/dev/drm/nouveau/core/engine/perfmon/nouveau_engine_perfmon_base.c
index 63013812f7..7ce842414a 100644
--- a/sys/dev/drm/nouveau/core/engine/perfmon/nouveau_engine_perfmon_base.c
+++ b/sys/dev/drm/nouveau/core/engine/perfmon/nouveau_engine_perfmon_base.c
@@ -49,7 +49,7 @@ nouveau_perfsig_find_(struct nouveau_perfdom *dom, const char *name, u32 size)
 		}
 	} else {
 		for (i = 0; i < dom->signal_nr; i++) {
-			snprintf(path, sizeof(path), "/%s/%02x", dom->name, i);
+			ksnprintf(path, sizeof(path), "/%s/%02x", dom->name, i);
 			if (!strncmp(name, path, size))
 				return &dom->signal[i];
 		}
@@ -58,7 +58,7 @@ nouveau_perfsig_find_(struct nouveau_perfdom *dom, const char *name, u32 size)
 	return NULL;
 }
 
-struct nouveau_perfsig *
+static struct nouveau_perfsig *
 nouveau_perfsig_find(struct nouveau_perfmon *ppm, const char *name, u32 size,
 		     struct nouveau_perfdom **pdom)
 {
@@ -139,7 +139,7 @@ nouveau_perfctr_query(struct nouveau_object *object, void *data, u32 size)
 
 	if (si >= 0) {
 		if (raw || !(name = dom->signal[si].name)) {
-			snprintf(args->v0.name, sizeof(args->v0.name),
+			ksnprintf(args->v0.name, sizeof(args->v0.name),
 				 "/%s/%02x", dom->name, si);
 		} else {
 			strncpy(args->v0.name, name, sizeof(args->v0.name));
@@ -405,11 +405,11 @@ nouveau_perfdom_new(struct nouveau_perfmon *ppm, const char *name, u32 mask,
 				return -ENOMEM;
 
 			if (mask) {
-				snprintf(dom->name, sizeof(dom->name),
+				ksnprintf(dom->name, sizeof(dom->name),
 					 "%s/%02x/%02x", name, i,
 					 (int)(sdom - spec));
 			} else {
-				snprintf(dom->name, sizeof(dom->name),
+				ksnprintf(dom->name, sizeof(dom->name),
 					 "%s/%02x", name, (int)(sdom - spec));
 			}
 
diff --git a/sys/dev/drm/nouveau/core/include/core/device.h b/sys/dev/drm/nouveau/core/include/core/device.h
index 8743766454..96b4ada11d 100644
--- a/sys/dev/drm/nouveau/core/include/core/device.h
+++ b/sys/dev/drm/nouveau/core/include/core/device.h
@@ -160,8 +160,8 @@ nv_device_is_pci(struct nouveau_device *device)
 static inline struct device *
 nv_device_base(struct nouveau_device *device)
 {
-	return nv_device_is_pci(device) ? &device->pdev->dev :
-					  &device->platformdev->dev;
+	return nv_device_is_pci(device) ? device->pdev->dev :
+					  device->pdev->dev;
 }
 
 resource_size_t
diff --git a/sys/dev/drm/nouveau/core/include/core/engine.h b/sys/dev/drm/nouveau/core/include/core/engine.h
index 666d06de77..b1d7dd3292 100644
--- a/sys/dev/drm/nouveau/core/include/core/engine.h
+++ b/sys/dev/drm/nouveau/core/include/core/engine.h
@@ -13,7 +13,7 @@ struct nouveau_engine {
 	struct nouveau_oclass *sclass;
 
 	struct list_head contexts;
-	spinlock_t lock;
+	struct spinlock lock;
 
 	void (*tile_prog)(struct nouveau_engine *, int region);
 	int  (*tlb_flush)(struct nouveau_engine *);
diff --git a/sys/dev/drm/nouveau/core/include/core/event.h b/sys/dev/drm/nouveau/core/include/core/event.h
index 51e55d0333..aa5802a3f9 100644
--- a/sys/dev/drm/nouveau/core/include/core/event.h
+++ b/sys/dev/drm/nouveau/core/include/core/event.h
@@ -16,8 +16,8 @@ struct nvkm_event {
 	int types_nr;
 	int index_nr;
 
-	spinlock_t refs_lock;
-	spinlock_t list_lock;
+	struct spinlock refs_lock;
+	struct spinlock list_lock;
 	struct list_head list;
 	int *refs;
 };
diff --git a/sys/dev/drm/nouveau/core/include/core/namedb.h b/sys/dev/drm/nouveau/core/include/core/namedb.h
index f5b5fd8e1f..51b6121db0 100644
--- a/sys/dev/drm/nouveau/core/include/core/namedb.h
+++ b/sys/dev/drm/nouveau/core/include/core/namedb.h
@@ -7,7 +7,7 @@ struct nouveau_handle;
 
 struct nouveau_namedb {
 	struct nouveau_parent base;
-	rwlock_t lock;
+	struct lock lock;
 	struct list_head list;
 };
 
